
package org.jhotdraw.figures; 
import org.jhotdraw.framework.*; 
import org.jhotdraw.standard.LocatorHandle; 
import org.jhotdraw.standard.SingleFigureEnumerator; 
import org.jhotdraw.util.Undoable; 
import org.jhotdraw.util.UndoableAdapter; 
import java.awt.*; 
public  class  PolyLineHandle  extends LocatorHandle {
		private int fIndex;

		public PolyLineHandle(PolyLineFigure owner, Locator l, int index) {	super(owner, l);	fIndex = index;	}

		public void invokeStart(int x, int y, DrawingView view) {	setUndoActivity(createUndoActivity(view, fIndex));	getUndoActivity().setAffectedFigures(new SingleFigureEnumerator(owner()));	((PolyLineHandle.UndoActivity)getUndoActivity()).setOldPoint(new Point(x,y));	}

		public void invokeStep(int x, int y, int anchorX, int anchorY, DrawingView view) {	int currentIndex = ((PolyLineHandle.UndoActivity)getUndoActivity()).getPointIndex();	myOwner().setPointAt(new Point(x, y), currentIndex);	}

		public void invokeEnd(int x, int y, int anchorX, int anchorY, DrawingView view) {	if ((x == anchorX) && (y == anchorY)) {	setUndoActivity(null);	}	}

		private PolyLineFigure myOwner() {	return (PolyLineFigure)owner();	}

		protected Undoable createUndoActivity(DrawingView newView, int newPointIndex) {	return new PolyLineHandle.UndoActivity(newView, newPointIndex);	}

		public static  class  UndoActivity  extends UndoableAdapter {
			private Point myOldPoint;

			private int myPointIndex;

			public UndoActivity(DrawingView newView, int newPointIndex) {	super(newView);	setUndoable(true);	setRedoable(true);	setPointIndex(newPointIndex);	}

			public boolean undo() {	if (!super.undo()) {	return false;	}	return movePointToOldLocation();	}

			public boolean redo() {	if (!isRedoable()) {	return false;	}	return movePointToOldLocation();	}

			protected boolean movePointToOldLocation() {	FigureEnumeration fe = getAffectedFigures();	if (!fe.hasNextFigure()) {	return false;	}	PolyLineFigure figure = (PolyLineFigure)fe.nextFigure();	Point backupPoint = figure.pointAt(getPointIndex());	figure.setPointAt(getOldPoint(), getPointIndex());	setOldPoint(backupPoint);	return true;	}

			public void setOldPoint(Point newOldPoint) {	myOldPoint = newOldPoint;	}

			public Point getOldPoint() {	return myOldPoint;	}

			public void setPointIndex(int newPointIndex) {	myPointIndex = newPointIndex;	}

			public int getPointIndex() {	return myPointIndex;	}


	}


}
